Name:           flint
Version:        1.0.17
Release:        1%{?dist}
Summary:        Fast Library for Number Theory
Group:          Applications/Engineering
License:        GPLv2+
URL:            http://www.flintlib.org/
Source0:        http://www.flintlib.org/flint-%{version}.tar.gz
# Add a soname for the shared library
Patch0:         flint-1.0.17-add-soname.diff
# Build a static lib (since upstream doesn't keep track of compatible
# interfaces a soname really makes no sense
Patch1:         flint-1.0.17-add-static-lib.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  gmp-devel


%description
FLINT is a C library for doing number theory, written by William Hart
and David Harvey.


%package        devel
Summary:        Development files for FLINT
Group:          Development/Libraries
Provides:       %{name}-static = %{version}-%{release}
Requires:       %{name} = %{version}-%{release}


%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q
sed -i -e 's|^LIBDIR=.*$|LIBDIR=%{_libdir}|'             makefile
sed -i -e 's|^INCLUDEDIR=.*$|INCLUDEDIR=%{_includedir}|' makefile
sed -i -e 's|^DOCDIR=.*$|DOCDIR=%{_docdir}|'             makefile
sed -i -e 's|^CFLAGS =.*$|CFLAGS = $(INCS) %{optflags} -lgmp|' makefile
%patch0
%patch1


%build
make %{?_smp_mflags} MAKECMDGOALS=library
make lib%{name}.so
make lib%{name}.a


%install
rm -rf $RPM_BUILD_ROOT
# generated in build: mpQS libflint.so libflint.a
install -d -m 755 $RPM_BUILD_ROOT%{_libdir}
install -p -m 644 lib%{name}.a $RPM_BUILD_ROOT%{_libdir}/
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -p -m 755 mpQS $RPM_BUILD_ROOT%{_bindir}/
# install the headers somehow...
install -d -m 755 $RPM_BUILD_ROOT%{_includedir}/%{name}
for header in *.h; do
  install -p -m 644 $header $RPM_BUILD_ROOT%{_includedir}/%{name}/
done

# Skip on installing the .so for now since upstream doesn't support it
#install -p -m 755 lib%{name}.so.0 $RPM_BUILD_ROOT%{_libdir}/
#%post -p /sbin/ldconfig
#%postun -p /sbin/ldconfig


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc doc/%{name}-%{version}.pdf
%{_bindir}/mpQS


%files devel
%defattr(-,root,root,-)
%{_includedir}/flint
%{_libdir}/lib%{name}.a


%changelog
* Sat Nov 29 2008 Conrad Meyer <konrad@tylerc.org> - 1.0.17-1
- Initial package.
